---
title: Basics of HTTP
slug: Web/HTTP/Basics_of_HTTP
tags:
  - Guide
  - HTTP
  - Overview
---
<div>{{HTTPSidebar}}</div>

<p>HTTP is an extensible protocol that relies on concepts like resources and Uniform Resource Identifiers (URIs), simple message structure, and client-server communication flow. On top of these basic concepts, numerous extensions have been developed over the years that add updated functionality and semantics with new HTTP methods or headers.</p>

<h2 id="Articles">Articles</h2>

<dl>
 <dt><a href="/en-US/docs/Web/HTTP/Overview">Overview of HTTP</a></dt>
 <dd>Describes what HTTP is and its role in web architecture, including its position in the protocol stack.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Evolution_of_HTTP">Evolution of HTTP</a></dt>
 <dd>HTTP was created in the early 1990s and has been extended several times. This article goes through its history and describes HTTP/0.9, HTTP/1.0, HTTP/1.1, and the modern HTTP/2, as well as novelties introduced over the years.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Resources_and_URIs">Resources and URIs</a></dt>
 <dd>A brief introduction to the concept of resources, identifiers, and locations on the web.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Identifying_resources_on_the_Web">Identifying resources on the Web</a></dt>
 <dd>Describes how web resources are referenced and how to locate them.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs">Data URIs</a></dt>
 <dd>A specific kind of URI that directly embeds the resource it represents. Data URIs are very convenient, but have some caveats.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Resource_URLs">Resource URLs</a> {{Non-standard_Inline}}</dt>
 <dd>Resource URLs, those prefixed with the <code>resource</code> scheme are used by Firefox and Firefox browser extensions to load resources internally, but is also available to some sites the browser connects to as well.</dd>
 <dt>Separating identity and location of a resource: The Alt-Svc HTTP header</dt>
 <dd>Most of the time the identity and location of a web resource are shared, this can be changed with the {{HTTPHeader("Alt-Svc")}} header.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types">MIME types</a></dt>
 <dd>Since HTTP/1.0, different types of content can be transmitted. This article explains how this is accomplished using the {{HTTPHeader("Content-Type")}} header and the MIME standard.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Choosing_between_www_and_non-www_URLs">Choosing between www and non-www URLs</a></dt>
 <dd>This article provides guidance on how to choose whether to use a www-prefixed domain or not, along with the consequences of that choice.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Flow_of_an_HTTP_session">Flow of an HTTP session</a></dt>
 <dd>This fundamental article describes a typical HTTP session: What happens under the hood when you click on a link in your browser.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Messages">HTTP Messages</a></dt>
 <dd>HTTP Messages transmitted during requests or responses have a very clear structure. This introductory article describes this structure, its purpose, and its possibilities.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Frame_and_message_structure_in_HTTP_2">Frame and message structure in HTTP/2</a></dt>
 <dd>HTTP/2 encapsulates and represents HTTP/1.x messages in a binary frame. This article explains the frame structure, its purpose, and the way it's encoded.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Connection_management_in_HTTP_1.x">Connection management in HTTP/1.x</a></dt>
 <dd>HTTP/1.1 was the first version of HTTP to support persistent connection and pipelining. This article explains both concepts.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Connection_management_in_HTTP_2">Connection management in HTTP/2</a></dt>
 <dd>HTTP/2 completely revisited how connections are created and maintained. This article explains how HTTP frames allow multiplexing and solve the 'head-of-line' blocking problem of former HTTP versions.</dd>
 <dt><a href="/en-US/docs/Web/HTTP/Content_negotiation">Content Negotiation</a></dt>
 <dd>HTTP introduces a set of headers, starting with <code><a href="/en-US/docs/Web/HTTP/Headers/Accept">Accept</a></code> as a way for a browser to announce the format, language, or encoding it prefers. This article explains how this advertisement happens, how the server is expected to react, and how it chooses the most adequate response.</dd>
</dl>
